VERSION 5.00
Begin VB.UserControl SVDTPicker 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ControlContainer=   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "SVDTPicker.ctx":0000
   Begin VB.Timer tmedit 
      Enabled         =   0   'False
      Interval        =   2000
      Left            =   1110
      Top             =   2715
   End
   Begin VB.VScrollBar vUpDown 
      Height          =   255
      Left            =   3075
      Max             =   100
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   1350
      Visible         =   0   'False
      Width           =   360
   End
   Begin VB.PictureBox pcVrednost 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   195
      Left            =   405
      ScaleHeight     =   135
      ScaleWidth      =   1140
      TabIndex        =   1
      Top             =   525
      Width           =   1200
   End
   Begin VB.CommandButton cmdDropDown 
      Height          =   270
      Left            =   1920
      Picture         =   "SVDTPicker.ctx":0312
      Style           =   1  'Graphical
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   1080
      Visible         =   0   'False
      Width           =   285
   End
End
Attribute VB_Name = "SVDTPicker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'CSEH: ErrReport
Option Explicit
Option Compare Text

Public Enum enumFormatDatuma
    dtLongDate = 1
    dtShortDate = 2
    dtTime = 3
    dtCustom = 4
End Enum

Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

Dim p_bPrikaziKalendar As Boolean

Private p_dtDatum As Date
Private p_lFormat As enumFormatDatuma
Private p_sCustomFormat As String
Private p_bUpDown As Boolean
Private p_dtMinDatum As Date
Private p_dtMaxDatum As Date

Private Const KarakteriUFormatu = "dMyHmstn"
Dim sSelektovaniPodatak As String
Dim lPozicijaSelektovanogPodatka As Long

Dim lPocetakSelekcije As Long
Dim lKrajSelekcije As Long
Dim bInFocus As Boolean
'Dim p_bRedraw As Boolean

Dim sNoviBroj As String

Const lOffsetX = 30

Public Event Change()
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event Click()
Public Event DblClick()
Public Event CalendarShow(Cancel As Boolean)
Public Event CalendarHide()

Private WithEvents fKalendar As frmKalendar
Attribute fKalendar.VB_VarHelpID = -1

Private Sub cmdDown_Click()

    pcVrednost_KeyDown vbKeyDown, 0

End Sub

Private Sub cmdDown_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

    pcVrednost.SetFocus

End Sub

Private Sub cmdDropDown_Click()
   
    Dim tyRect As RECT
    Dim bCancel As Boolean
    RaiseEvent CalendarShow(bCancel)
    
    If bCancel = False Then
        GetWindowRect UserControl.hwnd, tyRect

        p_bPrikaziKalendar = True

        With fKalendar
            .Left = tyRect.Left * Screen.TwipsPerPixelX
            .Top = tyRect.Top * Screen.TwipsPerPixelY + UserControl.Height
            SetWindowsStyle .hwnd
            .PrikaziKalendar p_dtDatum
            .Show
        End With

    Else
        pcVrednost.SetFocus
    End If
    
End Sub

Private Sub cmdUp_Click()

    pcVrednost_KeyDown vbKeyUp, 0

End Sub

Private Sub cmdUp_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

    pcVrednost.SetFocus

End Sub

Private Sub fKalendar_DatumPromenjen(dtNoviDatum As Date)

    Value = dtNoviDatum
    pDraw

End Sub

Private Sub fKalendar_Hide()

    RaiseEvent CalendarHide
    pcVrednost_MouseDown 0, 0, 0, 0

End Sub

Private Sub pcVrednost_Click()

    RaiseEvent Click

End Sub

Private Sub pcVrednost_DblClick()

    RaiseEvent DblClick

End Sub

Private Sub pcVrednost_GotFocus()

    bInFocus = True
    If lPocetakSelekcije = 0 And lKrajSelekcije = 0 Then
        pcVrednost_MouseDown 0, 0, 1, 0
    Else
        pDraw
    End If

End Sub

Private Sub pcVrednost_KeyDown(KeyCode As Integer, Shift As Integer)

    Dim lDuzinaFormata As Long, X As Long
    Dim sFormat As String, sText As String
    Dim sInterval As String
    Dim lTmp As Long, lNovaGodina As Long
     
    RaiseEvent KeyDown(KeyCode, Shift)
    
    sFormat = GetFormatString
    lDuzinaFormata = Len(sFormat)
    sText = Format$(p_dtDatum, sFormat)
    
    If sSelektovaniPodatak = "" Then sSelektovaniPodatak = Left$(Trim$(sFormat), 1)
    If sSelektovaniPodatak = "m" Then

        For X = lPozicijaSelektovanogPodatka - 1 To 1 Step -1
            If InStr(1, KarakteriUFormatu, Mid$(sFormat, X, 1)) > 0 And Mid$(sFormat, X, 1) <> sSelektovaniPodatak Then
                Exit For
            End If
        Next

        If X > 0 Then
            If Mid$(sFormat, X, 1) Like "h" Then
                sInterval = "n"
            Else
                sInterval = "m"
            End If
        Else
            sInterval = "m"
        End If
    ElseIf sSelektovaniPodatak = "y" Then
        sInterval = "yyyy"
    Else
        sInterval = sSelektovaniPodatak
    End If
        
    Select Case KeyCode

        Case vbKeyUp
            sNoviBroj = ""
            tmedit.Enabled = False
            PromeniDatum sInterval, 1
            'Value = DateAdd(sInterval, 1, p_dtDatum)

        Case vbKeyDown
            sNoviBroj = ""
            tmedit.Enabled = False
            If Shift = vbAltMask Then
                cmdDropDown_Click
            Else
                PromeniDatum sInterval, -1
                'Value = DateAdd(sInterval, -1, p_dtDatum)
            End If
            
        Case vbKeyLeft
            sNoviBroj = ""
            tmedit.Enabled = False

            For X = lPozicijaSelektovanogPodatka - 1 To 1 Step -1
                If InStr(1, KarakteriUFormatu, Mid$(sFormat, X, 1)) > 0 And sSelektovaniPodatak <> Mid$(sFormat, X, 1) Then
                    Exit For
                End If
            Next

            If X > 0 Then
                pcVrednost_MouseDown 1, 0, pcVrednost.TextWidth(Format$(p_dtDatum, Left$(sFormat, X))), 0
            End If
        
        Case vbKeyRight
            sNoviBroj = ""
            tmedit.Enabled = False

            For X = lPozicijaSelektovanogPodatka + 1 To lDuzinaFormata
                If InStr(1, KarakteriUFormatu, Mid$(sFormat, X, 1)) > 0 Then
                    Exit For
                End If
            Next

            lTmp = X

            For X = lTmp To lDuzinaFormata
                If Mid$(sFormat, X, 1) <> Mid$(sFormat, lTmp, 1) Then
                    Exit For
                End If
            Next

            If X > lDuzinaFormata Then X = lDuzinaFormata
            pcVrednost_MouseDown 1, 0, pcVrednost.TextWidth(Format$(p_dtDatum, Left$(sFormat, X))), 0

        Case vbKeyEscape
            sNoviBroj = ""
            tmedit.Enabled = False

        Case vbKeyReturn
            If sNoviBroj <> "" Then tmedit_Timer
    
        Case vbKey0 To vbKey9, vbKeyNumpad0 To vbKeyNumpad9
            If KeyCode > 57 Then
                KeyCode = KeyCode - 48
            End If
            If sNoviBroj = "" Then
                sNoviBroj = CLng(Chr$(KeyCode))
                tmedit.Enabled = True
            Else
                sNoviBroj = sNoviBroj & Chr$(KeyCode)

                Select Case sInterval

                    Case "d"
                        Dim lMaxDana As Long
                        lMaxDana = Day(DateSerial(Year(p_dtDatum), Month(p_dtDatum) + 1, 0))
                        If sNoviBroj > lMaxDana Then sNoviBroj = lMaxDana
                        Value = DateAdd("d", sNoviBroj - Day(p_dtDatum), p_dtDatum)
                        sNoviBroj = ""
                        tmedit.Enabled = False

                    Case "m"
                        If sNoviBroj > 12 Then sNoviBroj = 12
                        Value = DateAdd("m", sNoviBroj - Month(p_dtDatum), p_dtDatum)
                        sNoviBroj = ""
                        tmedit.Enabled = False

                    Case "yyyy"

                        For X = lPozicijaSelektovanogPodatka To 1 Step -1
                            If InStr(1, KarakteriUFormatu, Mid$(sFormat, X, 1)) = 0 Or Mid$(sFormat, X, 1) <> sSelektovaniPodatak Then
                                Exit For
                            End If
                        Next

                        If Len(sNoviBroj) = lPozicijaSelektovanogPodatka - X Then
                            ' u slucaju da smo stavili da se ne prikazuju sve 4 cifre
                            lNovaGodina = Format$("1/1/" & sNoviBroj, "yyyy")
                            If lNovaGodina > Year(p_dtMaxDatum) Then sNoviBroj = Year(p_dtMaxDatum)
                            If lNovaGodina < Year(p_dtMinDatum) Then sNoviBroj = Year(p_dtMinDatum)
                            Value = DateAdd("yyyy", lNovaGodina - Year(p_dtDatum), p_dtDatum)
                            sNoviBroj = ""
                            tmedit.Enabled = False
                        End If

                    Case "h"
                        If sNoviBroj > 23 Then sNoviBroj = 23
                        Value = DateAdd("h", sNoviBroj - Hour(p_dtDatum), p_dtDatum)
                        sNoviBroj = ""
                        tmedit.Enabled = False

                    Case "n"
                        If sNoviBroj > 59 Then sNoviBroj = 59
                        Value = DateAdd("n", sNoviBroj - Minute(p_dtDatum), p_dtDatum)
                        sNoviBroj = ""
                        tmedit.Enabled = False

                    Case "s"
                        If sNoviBroj > 59 Then sNoviBroj = 59
                        Value = DateAdd("s", sNoviBroj - Second(p_dtDatum), p_dtDatum)
                        sNoviBroj = ""
                        tmedit.Enabled = False
                
                End Select

            End If
            
    End Select

    'p_bRedraw = True
    pcVrednost_MouseDown 1, 0, pcVrednost.TextWidth(Format$(p_dtDatum, Left$(sFormat, lPozicijaSelektovanogPodatka))), 0

End Sub

Private Sub pcVrednost_KeyPress(KeyAscii As Integer)

    RaiseEvent KeyPress(KeyAscii)

End Sub

Private Sub pcVrednost_KeyUp(KeyCode As Integer, Shift As Integer)

    RaiseEvent KeyUp(KeyCode, Shift)

End Sub

Private Sub pcVrednost_LostFocus()

    bInFocus = False

End Sub

Private Sub pcVrednost_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Dim sFormat As String, lDuzinaFormata As Long
    Dim sStaroPolje As String, sNovoPolje As String * 1
    Dim z As Long
    Dim sText As String, sTmp As String
    
    RaiseEvent MouseDown(Button, Shift, X, Y)

    With pcVrednost
        ' uzimamo format po kom ce datum biti ispisan
        sFormat = GetFormatString
        lDuzinaFormata = Len(sFormat)
        
        ' pocetna koordinata selekcije je samo offseet od kog pocinjemo da pisemo datum
        lPocetakSelekcije = lOffsetX
        
        ' prolazimo kroz ceo format

        For z = 1 To lDuzinaFormata
        
            ' pamtimo koji je trenutni i EX karakter u formatu
            ' ovo nam sluzi da znamo odakle i dokle da selektujemo tekst
            sNovoPolje = Mid$(sFormat, z, 1)
            
            ' ako je ovo prvi prolaz staro karakter je isti kao i prvi
            If sStaroPolje = "" Then
                sStaroPolje = sNovoPolje
            End If
            
            ' ako se novi karakter razlikuje od starog znaci da smo dosli do drugog polja u datumu
            ' sad proveravamo da li je predhodno polje to jie treba da selektujemo
            If Left$(sStaroPolje, 1) <> sNovoPolje Then
                ' prvo proveravamo da li je stari karakter uopste dozvoljen u formatiranju datuma
                If InStr(1, KarakteriUFormatu, Left$(sStaroPolje, 1)) > 0 Then
                    ' jeste: kraj selekcije je kraj formatiranog datume
                    lKrajSelekcije = .TextWidth(Format$(p_dtDatum, Left$(sFormat, z - 1))) + lOffsetX
                Else
                    lPocetakSelekcije = .TextWidth(Format$(p_dtDatum, Left$(sFormat, z - 1))) + lOffsetX
                End If
                
                ' proveravamo da li smo kliknuli na taj podatak iz datuma
                If ((lPocetakSelekcije + lOffsetX <= X And X <= lKrajSelekcije + lOffsetX) Or _
                   (X < lPocetakSelekcije + lOffsetX And lPocetakSelekcije < lKrajSelekcije)) Then
                    Exit For
                End If
                    
                sStaroPolje = sNovoPolje
                lPocetakSelekcije = .TextWidth(Format$(p_dtDatum, Left$(sFormat, z - 1))) + lOffsetX
            End If
    
        Next
        
        If z > lDuzinaFormata Then
            lKrajSelekcije = .TextWidth(Format$(p_dtDatum, sFormat)) + lOffsetX
        End If

        lPocetakSelekcije = (lPocetakSelekcije) / Screen.TwipsPerPixelX
        lKrajSelekcije = (lKrajSelekcije) / Screen.TwipsPerPixelX
    
        lPozicijaSelektovanogPodatka = z - 1
        sSelektovaniPodatak = Left$(sStaroPolje, 1)
    End With

    pDraw

End Sub

Private Sub pcVrednost_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    RaiseEvent MouseMove(Button, Shift, X, Y)

End Sub

Private Sub pcVrednost_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

    RaiseEvent MouseUp(Button, Shift, X, Y)

End Sub

Private Sub tmedit_Timer()

    Dim sInterval As String, sFormat As String, lDuzinaFormata As Long, sText As String
    Dim lTmp As Long, X As Long, lNovaGodina As Long
    '    p_bRedraw = False
    sFormat = GetFormatString
    lDuzinaFormata = Len(sFormat)
    sText = Format$(p_dtDatum, sFormat)
    
    If sSelektovaniPodatak = "" Then sSelektovaniPodatak = Left$(Trim$(sFormat), 1)
    If sSelektovaniPodatak = "m" Then

        For X = lPozicijaSelektovanogPodatka - 1 To 1 Step -1
            If InStr(1, KarakteriUFormatu, Mid$(sFormat, X, 1)) > 0 And Mid$(sFormat, X, 1) <> sSelektovaniPodatak Then
                Exit For
            End If
        Next

        If Mid$(sFormat, X, 1) Like "h" Then
            sInterval = "n"
        Else
            sInterval = "m"
        End If
    ElseIf sSelektovaniPodatak = "y" Then
        sInterval = "yyyy"
    Else
        sInterval = sSelektovaniPodatak
    End If

    Select Case sInterval

        Case "d"
            Dim lMaxDana As Long
            lMaxDana = Day(DateSerial(Year(p_dtDatum), Month(p_dtDatum) + 1, 0))
            If sNoviBroj > lMaxDana Then sNoviBroj = lMaxDana
            Value = DateAdd("d", sNoviBroj - Day(p_dtDatum), p_dtDatum)
            sNoviBroj = ""
            tmedit.Enabled = False

        Case "m"
            If sNoviBroj > 12 Then sNoviBroj = 12
            Value = DateAdd("m", sNoviBroj - Month(p_dtDatum), p_dtDatum)
            sNoviBroj = ""
            tmedit.Enabled = False

        Case "yyyy"

            For X = lPozicijaSelektovanogPodatka To 1 Step -1
                If InStr(1, KarakteriUFormatu, Mid$(sFormat, X, 1)) = 0 Or Mid$(sFormat, X, 1) <> sSelektovaniPodatak Then
                    Exit For
                End If
            Next

            ' u slucaju da smo stavili da se ne prikazuju sve 4 cifre
            lNovaGodina = Format$("1/1/" & sNoviBroj, "yyyy")
            If lNovaGodina > Year(p_dtMaxDatum) Then sNoviBroj = Year(p_dtMaxDatum)
            If lNovaGodina < Year(p_dtMinDatum) Then sNoviBroj = Year(p_dtMinDatum)
            Value = DateAdd("yyyy", lNovaGodina - Year(p_dtDatum), p_dtDatum)
            sNoviBroj = ""
            tmedit.Enabled = False

        Case "h"
            If sNoviBroj > 23 Then sNoviBroj = 23
            Value = DateAdd("h", sNoviBroj - Hour(p_dtDatum), p_dtDatum)
            sNoviBroj = ""
            tmedit.Enabled = False

        Case "n"
            If sNoviBroj > 59 Then sNoviBroj = 59
            Value = DateAdd("n", sNoviBroj - Minute(p_dtDatum), p_dtDatum)
            sNoviBroj = ""
            tmedit.Enabled = False

        Case "s"
            If sNoviBroj > 59 Then sNoviBroj = 59
            Value = DateAdd("s", sNoviBroj - Second(p_dtDatum), p_dtDatum)
            sNoviBroj = ""
            tmedit.Enabled = False
                
    End Select
                
    sNoviBroj = ""
    tmedit.Enabled = False
    pcVrednost_MouseDown 1, 0, pcVrednost.TextWidth(Format$(p_dtDatum, Left$(sFormat, lPozicijaSelektovanogPodatka))), 0

End Sub

Private Sub UserControl_ExitFocus()

    bInFocus = False
    pDraw

End Sub

Private Sub UserControl_Initialize()

    Set fKalendar = New frmKalendar

End Sub

Private Sub UserControl_InitProperties()

    p_dtDatum = #1/1/2000#
    p_lFormat = dtShortDate
    p_sCustomFormat = ""
    p_dtMinDatum = #1/1/1601#
    p_dtMaxDatum = "12/31/9999"
    p_bUpDown = False
End Sub

Private Sub UserControl_Paint()

    pDraw

End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    p_dtDatum = PropBag.ReadProperty("Datum", Now)
    p_lFormat = PropBag.ReadProperty("Format", dtShortDate)
    p_sCustomFormat = PropBag.ReadProperty("CustomFormat", "")
    p_dtMinDatum = PropBag.ReadProperty("MinDatum")
    p_dtMaxDatum = PropBag.ReadProperty("MaxDatum")
    p_bUpDown = PropBag.ReadProperty("UpDown")
    If p_bUpDown = False Then
        cmdDropDown.Visible = True
    Else
        vUpDown.Visible = True
    End If
End Sub

Private Sub UserControl_Resize()

    With pcVrednost
        .Height = UserControl.Height
        .Left = 0
        .Top = 0
        .Width = UserControl.Width
    End With
    
    With cmdDropDown
        .Height = UserControl.Height - 60
        .Width = 250
        .Left = UserControl.Width - .Width - 30
        .Top = 30
        .ZOrder 0
    End With
    
    With vUpDown
        .Height = UserControl.Height - 60
        .Width = 300
        .Left = UserControl.Width - .Width - 30
        .Top = 30
        .ZOrder 0
        .Value = 50
    End With

    pDraw

End Sub

Public Property Get Value() As Date
Attribute Value.VB_UserMemId = 0

    Value = p_dtDatum

End Property

Public Property Let Value(ByVal dtNoviDatum As Date)

    p_dtDatum = dtNoviDatum
    RaiseEvent Change
    PropertyChanged "Datum"
    pDraw

End Property

Public Property Get FormatDatuma() As enumFormatDatuma

    FormatDatuma = p_lFormat

End Property

Public Property Let FormatDatuma(ByVal tyNoviFormat As enumFormatDatuma)

    p_lFormat = tyNoviFormat
    PropertyChanged "Format"
    pDraw

End Property

Private Sub UserControl_Terminate()

    Unload fKalendar

End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    PropBag.WriteProperty "Datum", CStr(p_dtDatum)
    PropBag.WriteProperty "Format", CStr(p_lFormat)
    PropBag.WriteProperty "CustomFormat", CStr(p_sCustomFormat)
    PropBag.WriteProperty "MinDatum", CStr(p_dtMinDatum)
    PropBag.WriteProperty "MaxDatum", CStr(p_dtMaxDatum)
    PropBag.WriteProperty "UpDown", CStr(p_bUpDown)
End Sub

Public Property Get CustomFormat() As String

    CustomFormat = p_sCustomFormat

End Property

Public Property Let CustomFormat(ByVal vNewValue As String)

    p_sCustomFormat = vNewValue
    PropertyChanged "CustomFormat"
    pDraw

End Property

Private Function GetFormatString() As String

    Select Case p_lFormat
    
        Case dtLongDate
            GetFormatString = fnGetDateFormat(LOCALE_SLONGDATE)

        Case dtShortDate
            GetFormatString = fnGetDateFormat(LOCALE_SSHORTDATE)
            
        Case dtTime
            GetFormatString = fnGetDateFormat(LOCALE_STIMEFORMAT)
            
        Case dtCustom
            GetFormatString = p_sCustomFormat
    End Select

End Function

Private Sub pDraw()

    Dim hReg As Long, hBrush As Long
    Dim tRect As RECT

    Dim sText As String
    
    'If p_bRedraw = True Then
    sText = Format$(p_dtDatum, GetFormatString)

    With pcVrednost
        .Cls

        If bInFocus = True Then

            With tRect
                .Top = 30 / Screen.TwipsPerPixelY
                .Left = lPocetakSelekcije
                .Right = lKrajSelekcije
                .Bottom = pcVrednost.TextHeight("88") / Screen.TwipsPerPixelY + 2
            End With

            hBrush = CreateSolidBrush(RGB(200, 200, 200))
            FillRect pcVrednost.hdc, tRect, hBrush
     
        End If
        .CurrentX = 30
        .CurrentY = 30
        .ForeColor = vbBlack
        pcVrednost.Print sText
        
        If sNoviBroj <> "" Then
            hBrush = CreateSolidBrush(vbWhite)
            FillRect pcVrednost.hdc, tRect, hBrush
            
            hBrush = CreateSolidBrush(RGB(200, 200, 200))
            FillRect pcVrednost.hdc, tRect, hBrush
        
            .CurrentX = tRect.Right * Screen.TwipsPerPixelX - .TextWidth(sNoviBroj) - lOffsetX
            .CurrentY = 30
            pcVrednost.Print sNoviBroj
        End If
        
    End With

    DeleteObject hBrush

End Sub

Public Property Get UpDown() As Boolean

    UpDown = p_bUpDown

End Property

Public Property Let UpDown(ByVal vNewValue As Boolean)

    p_bUpDown = vNewValue
    PropertyChanged "UpDown"
    If UpDown = False Then
        cmdDropDown.Visible = True
        vUpDown.Visible = False
    Else
        cmdDropDown.Visible = False
        vUpDown.Visible = True
    End If

End Property

Private Sub vUpDown_Change()

    If vUpDown.Value <> 50 Then
        If vUpDown.Value > 50 Then
            pcVrednost_KeyDown vbKeyDown, 0

        Else
            pcVrednost_KeyDown vbKeyUp, 0
        End If
        vUpDown.Value = 50
    End If

End Sub

Private Sub vUpDown_GotFocus()

    pcVrednost.SetFocus

End Sub

Public Property Get MinDate() As Date

    MinDate = p_dtMinDatum

End Property

Public Property Let MinDate(ByVal vNewValue As Date)

    p_dtMinDatum = vNewValue
    PropertyChanged "MinDate"

End Property

Public Property Get MaxDate() As Date

    MaxDate = p_dtMaxDatum

End Property

Public Property Let MaxDate(ByVal vNewValue As Date)

    p_dtMaxDatum = vNewValue
    PropertyChanged "MaxDate"

End Property

Private Sub PromeniDatum(sInterval As String, lDelta As Long)
    Dim lNoviMesec As Long, lNoviDan As Long, lNoviSat As Long, lNoviminut As Long, lNoviSekund As Long
    Dim lMaxDana As Long, lNovaGodina As Long

    Select Case sInterval

        Case "d"
            lNoviDan = Day(p_dtDatum) + lDelta
            lMaxDana = Day(DateSerial(Year(p_dtDatum), Month(p_dtDatum) + 1, 0))
            If lNoviDan = 0 Then lNoviDan = lMaxDana
            If lNoviDan = lMaxDana + 1 Then lNoviDan = 1
            
            Value = DateSerial(Year(p_dtDatum), Month(p_dtDatum), lNoviDan) + _
               TimeSerial(Hour(p_dtDatum), Minute(p_dtDatum), Second(p_dtDatum))

        Case "m"
            lNoviMesec = Month(p_dtDatum) + lDelta
            If lNoviMesec = 0 Then lNoviMesec = 12
            If lNoviMesec = 13 Then lNoviMesec = 1
            lMaxDana = Day(DateSerial(Year(p_dtDatum), lNoviMesec + 1, 0))
            If Day(p_dtDatum) > lMaxDana Then
                lNoviDan = lMaxDana
            Else
                lNoviDan = Day(p_dtDatum)
            End If
            Value = DateSerial(Year(p_dtDatum), lNoviMesec, lNoviDan) + _
               TimeSerial(Hour(p_dtDatum), Minute(p_dtDatum), Second(p_dtDatum))

        Case "yyyy"
            lNovaGodina = Year(p_dtDatum) + lDelta
            lMaxDana = Day(DateSerial(lNovaGodina, Month(p_dtDatum) + 1, 0))
            If Day(p_dtDatum) > lMaxDana Then
                lNoviDan = lMaxDana
            Else
                lNoviDan = Day(p_dtDatum)
            End If
            Value = DateSerial(lNovaGodina, Month(p_dtDatum), lNoviDan) + _
               TimeSerial(Hour(p_dtDatum), Minute(p_dtDatum), Second(p_dtDatum))

        Case "h"
            lNoviSat = Hour(p_dtDatum) + lDelta
            If lNoviSat = -1 Then lNoviSat = 23
            If lNoviSat = 24 Then lNoviSat = 0
            Value = DateSerial(Year(p_dtDatum), Month(p_dtDatum), Day(p_dtDatum)) + _
               TimeSerial(lNoviSat, Minute(p_dtDatum), Second(p_dtDatum))

        Case "n"
            lNoviminut = Minute(p_dtDatum) + lDelta
            If lNoviminut = -1 Then lNoviminut = 59
            If lNoviminut = 60 Then lNoviminut = 0
            Value = DateSerial(Year(p_dtDatum), Month(p_dtDatum), Day(p_dtDatum)) + _
               TimeSerial(Hour(p_dtDatum), lNoviminut, Second(p_dtDatum))

        Case "s"
            lNoviSekund = Second(p_dtDatum) + lDelta
            If lNoviSekund = -1 Then lNoviSekund = 59
            If lNoviSekund = 60 Then lNoviSekund = 0
            Value = DateSerial(Year(p_dtDatum), Month(p_dtDatum), Day(p_dtDatum)) + _
               TimeSerial(Hour(p_dtDatum), Minute(p_dtDatum), lNoviSekund)

    End Select

End Sub

