VERSION 5.00
Begin VB.Form frmKalendar 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   4095
   ClientLeft      =   15
   ClientTop       =   15
   ClientWidth     =   6930
   ControlBox      =   0   'False
   Icon            =   "frmKalendar.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4095
   ScaleWidth      =   6930
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtFocus 
      Height          =   465
      Left            =   5400
      TabIndex        =   5
      Top             =   495
      Width           =   1200
   End
   Begin VB.CommandButton cmdMesecPlus 
      Height          =   270
      Left            =   2640
      Picture         =   "frmKalendar.frx":058A
      Style           =   1  'Graphical
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   390
      Width           =   255
   End
   Begin VB.Timer tmHide 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   1080
      Top             =   1935
   End
   Begin VB.Frame fHeader 
      BackColor       =   &H00E0E0E0&
      BorderStyle     =   0  'None
      Height          =   1575
      Left            =   195
      TabIndex        =   0
      Top             =   135
      Width           =   2925
      Begin VB.VScrollBar vGodina 
         Height          =   390
         Left            =   1725
         Max             =   100
         TabIndex        =   6
         Top             =   210
         Value           =   50
         Visible         =   0   'False
         Width           =   225
      End
      Begin VB.CommandButton cmdMesecMinus 
         BackColor       =   &H00E0E0E0&
         Height          =   270
         Left            =   150
         Picture         =   "frmKalendar.frx":0A84
         Style           =   1  'Graphical
         TabIndex        =   3
         TabStop         =   0   'False
         Top             =   210
         Width           =   255
      End
      Begin VB.Label lbGodina 
         Alignment       =   2  'Center
         AutoSize        =   -1  'True
         Caption         =   "2005"
         BeginProperty Font 
            Name            =   "Tahoma"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Left            =   1260
         TabIndex        =   2
         Top             =   315
         Width           =   435
      End
      Begin VB.Label lbMesec 
         Alignment       =   2  'Center
         AutoSize        =   -1  'True
         Caption         =   "Januar"
         BeginProperty Font 
            Name            =   "Tahoma"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   195
         Left            =   615
         TabIndex        =   1
         Top             =   270
         Width           =   615
      End
   End
End
Attribute VB_Name = "frmKalendar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary

Dim p_dtDatum As Date
Dim lOffsetX As Long, lOffsetY As Long
Dim p_aDatum(6, 7) As Date  ' cuva sve datume za svaki dan u kalendaru

Public Event DatumPromenjen(dtNoviDatum As Date)
Public Event Hide()

Dim p_aMeseci(12) As String
Dim p_aDani(7) As String

Private Sub pDraw()

    Dim lDanUNedelji As Long
    Dim lKolona As Long, lRed As Long
    Dim dtTrenutniDatum As Date, dtPocetniDanUMesecu As Date
    
    Dim hFRgn As Long
    Dim hHBr As Long, hRedBrush As Long
    Dim lRgnStartX As Long, lRgnStartY As Long

    Dim PosX As Long, PosY As Long, sText As String
    Dim X As Long
    
    dtPocetniDanUMesecu = DateSerial(Year(p_dtDatum), Month(p_dtDatum), 1)
    lDanUNedelji = Weekday(dtPocetniDanUMesecu, vbMonday)

    With Me

        .Cls
        .FontBold = False
        hHBr = CreateSolidBrush(RGB(220, 220, 220))
        hRedBrush = CreateSolidBrush(RGB(220, 0, 0))

        lOffsetX = -130
        lOffsetY = fHeader.Height
        .ForeColor = vbGrayText
        ' ispisujemo nazive dana kao header tabele

        For X = 1 To 7
            ' p_aDani se ucitavaju u form_Load
            sText = p_aDani(X)
            .CurrentY = fHeader.Height
            .CurrentX = 320 * X - .TextWidth(sText) / 2 + lOffsetX
            Me.Print sText
        Next

        ' linija ispod naziva
        .ForeColor = vbBlack
        Me.Line (300 + lOffsetX - .TextWidth(sText) / 2, 200 + fHeader.Height)-(2200 + .TextWidth(sText) / 2, 200 + fHeader.Height)
    
        lOffsetX = -130
        lOffsetY = 130 + lOffsetY
        'crtamo celu tabelu

        For lRed = 1 To 6

            For lKolona = 1 To 7
                ' proracunavamo datum za stavku koju cemo da napiemo
                dtTrenutniDatum = DateAdd("d", (lRed - 1) * 7 + lKolona - lDanUNedelji, dtPocetniDanUMesecu) + TimeSerial(Hour(p_dtDatum), Minute(p_dtDatum), Second(p_dtDatum))
                ' cuvamo vrednost te stavke u array-u
                p_aDatum(lRed, lKolona) = dtTrenutniDatum
                ' pomeramo se na poziciju za crtanje
                PosY = 220 * lRed + lOffsetY
                PosX = 320 * lKolona + lOffsetX
                ' podesavamo pocetak regiona ako treba da se iscrta
                ' koordinate su postavljene odokativno :)
                lRgnStartX = (PosX - 135) / Screen.TwipsPerPixelX
                lRgnStartY = (PosY - 105) / Screen.TwipsPerPixelY
                If dtTrenutniDatum = p_dtDatum Then
                    ' ako je datum koji treba da napisemo jednak vrednosti koju ima kontrola
                    hFRgn = CreateRoundRectRgn(lRgnStartX, lRgnStartY, lRgnStartX + 20, lRgnStartY + 15, 10, 10)
                    FrameRgn .hdc, hFRgn, hHBr, 1, 1
                    FillRgn .hdc, hFRgn, hHBr
                End If
            
                If dtTrenutniDatum = Date Then
                    ' ako je datum koji treba da napisemo jednat trenutnom sistemskom datumu
                    ' ovo je crveni "krug"
                    hFRgn = CreateRoundRectRgn(lRgnStartX, lRgnStartY, lRgnStartX + 20, lRgnStartY + 15, 10, 10)
                    FrameRgn .hdc, hFRgn, hRedBrush, 1, 1
                End If
            
                ' uzimamo vrednost koju treba da napisemo
                sText = Day(dtTrenutniDatum)
                ' posto su koordinate u stvari centar tekst pomeramo se levo i gore tako da dan bude centriran
                .CurrentY = PosY - .TextHeight(sText) / 2
                .CurrentX = PosX - .TextWidth(sText) / 2
                
                If Month(dtTrenutniDatum) = Month(p_dtDatum) Then
                    .ForeColor = vbBlack
                Else
                    .ForeColor = vbGrayText
                End If
                
                Me.Print sText
            Next

        Next

        .ForeColor = vbBlack
        .FontBold = True
        .CurrentX = 500
        .CurrentY = 7 * 220 + fHeader.Height + 30 ' + lOffsetY '+ 200
        Me.Print "Today: " & Format$(Date, "dd.mm.yyyy")

        lRgnStartX = 100 / Screen.TwipsPerPixelX
        lRgnStartY = (7 * 220 + fHeader.Height + 30) / Screen.TwipsPerPixelY
    
        hFRgn = CreateRoundRectRgn(lRgnStartX, lRgnStartY, lRgnStartX + 20, lRgnStartY + 15, 10, 10)
        FrameRgn .hdc, hFRgn, hRedBrush, 1, 1
    End With
    
    lbMesec = p_aMeseci(Month(dtPocetniDanUMesecu))
    lbGodina = Year(dtPocetniDanUMesecu)

    lbMesec.Left = fHeader.Width / 2 - (lbMesec.Width + lbGodina.Width) / 2
    lbGodina.Left = lbMesec.Left + lbMesec.Width + 50
    vGodina.Left = lbGodina.Left + lbGodina.Width + 50
        
    DeleteObject hHBr
    DeleteObject hFRgn
    DeleteObject hRedBrush
    If Me.Visible = True Then
        txtFocus.SetFocus
    End If

End Sub

Public Sub PrikaziKalendar(ByVal dtDatum As Date)

    p_dtDatum = dtDatum
    pDraw
    tmHide.Enabled = True

End Sub

Private Sub cmdMesecMinus_Click()

    vGodina.Visible = False

    Value = DateAdd("m", -1, p_dtDatum)
    pDraw
    txtFocus.SetFocus

End Sub

Private Sub cmdMesecPlus_Click()

    vGodina.Visible = False

    Value = DateAdd("m", 1, p_dtDatum)
    pDraw
    txtFocus.SetFocus

End Sub

Private Sub fHeader_Click()

    vGodina.Visible = False

End Sub

Private Sub Form_Activate()

    txtFocus.SetFocus

End Sub

Private Sub Form_Load()

    Dim X As Long
    Me.Width = 8 * 300
    Me.Height = 6 * 220 + 400 + 200 + 300 ' 400 - fheader; 300 - zaglavlje kalendara; 300 - TODAY

    With fHeader
        .Width = Me.Width
        .Height = 400
        .Top = 0
        .Left = 0
    End With
    
    With cmdMesecMinus
        .Width = 250
        .Height = 100
        .Left = 50
        .Top = (fHeader.Height - .Height) / 2
    End With
    
    With cmdMesecPlus
        .Height = 100
        .Width = 250
        .Left = fHeader.Width - cmdMesecPlus.Width - 50
        .Top = (fHeader.Height - .Height) / 2
    End With
    
    With lbMesec
        .Top = (fHeader.Height - lbMesec.Height) / 2
        .Left = fHeader.Width / 2 - (.Width + lbGodina.Width) / 2
    End With
    
    With lbGodina
        .Top = lbMesec.Top
        .Left = lbMesec.Left + lbMesec.Width + 50
    End With
    
    With vGodina
        .Left = lbMesec.Left + lbMesec.Width + 100
        .Width = 200
        .Top = 10
        .Height = fHeader.Height - 10
    End With

    For X = 1 To 12
        p_aMeseci(X) = GetMonthName(X)
    Next
    
    For X = 1 To 7
        p_aDani(X) = GetDayName(X)
    Next

End Sub

Private Sub lbGodina_Click()

    vGodina.Visible = True

End Sub

Private Sub lbMesec_Click()

    vGodina.Visible = False

End Sub

Private Sub Form_Click()

    Dim lRed As Long, lKolona As Long
    
    vGodina.Visible = False
    pGetItemFromCoordinate lRed, lKolona
    If lRed <= 6 And lKolona <= 7 Then
        Value = p_aDatum(lRed, lKolona)
    End If
    If lRed = 7 Then
        Value = Date
    End If
    Me.Hide
    RaiseEvent Hide

End Sub

Private Function pGetItemFromCoordinate(lRed As Long, lKolona As Long) As Long

    Dim tPoint As POINTAPI
    Dim lTwipY As Long, lTwipX As Long
    GetCursorPos tPoint

    With Me
    
        lTwipY = tPoint.Y * Screen.TwipsPerPixelY - Me.Top - lOffsetY - 150
        lTwipX = tPoint.X * Screen.TwipsPerPixelX - Me.Left - lOffsetX - 150
    
        lRed = (lTwipY \ 220) + 1
        lKolona = (lTwipX \ 320) + 1
    
    End With
    
End Function

Private Sub txtFocus_KeyDown(KeyCode As Integer, Shift As Integer)

    Select Case KeyCode
    
        Case vbKeyUp
            Value = DateAdd("d", -7, p_dtDatum)

        Case vbKeyDown
            Value = DateAdd("d", 7, p_dtDatum)

        Case vbKeyLeft
            Value = DateAdd("d", -1, p_dtDatum)
        
        Case vbKeyRight
            Value = DateAdd("d", 1, p_dtDatum)
    
        Case vbKeyReturn
            KeyCode = 0
            Me.Hide
            RaiseEvent Hide
        Case vbKeyEscape
            KeyCode = 0
            Me.Hide
            RaiseEvent Hide
    End Select

    pDraw

End Sub

Private Sub tmHide_Timer()

    Dim lHwnd As Long

    lHwnd = GetForegroundWindow
    If lHwnd <> Me.hwnd And Me.Visible = True Then
        Me.Hide
        tmHide.Enabled = False
        RaiseEvent Hide
    End If

End Sub

Private Property Get Value() As Date

    Value = p_dtDatum

End Property

Private Property Let Value(ByVal vNewValue As Date)

    If p_dtDatum <> vNewValue Then
        p_dtDatum = vNewValue
        RaiseEvent DatumPromenjen(p_dtDatum)
    End If

End Property

Private Sub txtFocus_KeyPress(KeyAscii As Integer)

    KeyAscii = 0

End Sub


Private Sub vGodina_GotFocus()

    txtFocus.SetFocus

End Sub

Private Sub vGodina_Change()

    If vGodina.Value <> 50 Then
        If vGodina.Value > 50 Then
            Value = DateAdd("yyyy", 1, p_dtDatum)
        Else
            Value = DateAdd("yyyy", -1, p_dtDatum)
        End If
        vGodina.Value = 50
        pDraw
    End If

End Sub

